#line 1 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 1 "c:/users/antonius/documents/fat32 mp3 player no tft rev4/mp3_driver.h"
#line 32 "c:/users/antonius/documents/fat32 mp3 player no tft rev4/mp3_driver.h"
extern sfr sbit MP3_CS;
extern sfr sbit MP3_RST;
extern sfr sbit BSYNC;
extern sfr sbit DREQ;

extern sfr sbit LED;
extern sfr sbit Mmc_Chip_Select;


extern void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer);
extern void MP3_SCI_Write(char address, unsigned int data_in);
extern void MP3_SDI_Write_32(char *data_);
extern void MP3_SDI_Write(char data_);
extern void MP3_Set_default_Mode();
extern void MP3_Set_Volume(char left, char right);
extern void MP3_Reset_Time();
extern void MP3_Get_Decode_Time(unsigned int *time);
extern void VsSineTest(void);
#line 41 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
const char WRITE_CODE = 0x02;
const char READ_CODE = 0x03;

const char SCI_BASE_ADDR = 0x00;
const char SCI_MODE_ADDR = 0x00;
const char SCI_STATUS_ADDR = 0x01;
const char SCI_BASS_ADDR = 0x02;
const char SCI_CLOCKF_ADDR = 0x03;
const char SCI_DECODE_TIME_ADDR = 0x04;
const char SCI_AUDATA_ADDR = 0x05;
const char SCI_WRAM_ADDR = 0x06;
const char SCI_WRAMADDR_ADDR = 0x07;
const char SCI_HDAT0_ADDR = 0x08;
const char SCI_HDAT1_ADDR = 0x09;
const char SCI_AIADDR_ADDR = 0x0A;
const char SCI_VOL_ADDR = 0x0B;
const char SCI_AICTRL0_ADDR = 0x0C;
const char SCI_AICTRL1_ADDR = 0x0D;
const char SCI_AICTRL2_ADDR = 0x0E;
const char SCI_AICTRL3_ADDR = 0x0F;
#line 69 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_SCI_Write(char address, unsigned int data_in) {
 BSYNC = 1;

 MP3_CS = 0;
 SPI1_Write(WRITE_CODE);
 SPI1_Write(address);
 SPI1_Write( ((char *)&data_in)[1] );
 SPI1_Write( ((char *)&data_in)[0] );
 MP3_CS = 1;

 while (DREQ == 0);
}
#line 89 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer) {
 unsigned int temp;

 MP3_CS = 0;
 SPI1_Write(READ_CODE);
 SPI1_Write(start_address);

 while (words_count--) {
 temp = SPI_Read(0);
 temp <<= 8;
 temp += SPI_Read(0);
 *(data_buffer++) = temp;
 }

 MP3_CS = 1;

 while (DREQ == 0);
}
#line 115 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_SDI_Write(char data_) {



 MP3_CS = 1;


 BSYNC = 0;
 UART1_Write(data_);


 BSYNC = 1;

}
#line 137 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_Reset_Time(){
 MP3_SCI_Write(SCI_DECODE_TIME_ADDR, 0);
}
#line 148 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_Get_Decode_Time(unsigned int *time){
 MP3_SCI_Read(SCI_DECODE_TIME_ADDR, 1, time);
}
#line 159 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_SDI_Write_32(char *data_) {
 char i;

 Mmc_Chip_Select = 1;
 MP3_CS = 1;


 while (DREQ == 0);
 BSYNC = 0;
 for(i = 0; i < 32; i++)

 SPI1_Write(data_[i]);

 BSYNC = 1;
}
#line 182 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void MP3_Set_Volume(char left, char right) {
 unsigned int volume;

 volume = (left << 8) + right;
 MP3_SCI_Write(SCI_VOL_ADDR, volume);
}

void MP3_Set_default_Mode(){
 BSYNC = 1;
 MP3_CS = 1;


 MP3_RST = 0;
 Delay_ms(20);
 MP3_RST = 1;

 while (DREQ == 0);

 MP3_SCI_Write(SCI_MODE_ADDR, 0x000);
 MP3_SCI_Write(SCI_BASS_ADDR, 0x7A00);
 MP3_SCI_Write(SCI_CLOCKF_ADDR, 0xC000);
 MP3_SCI_Write(SCI_VOL_ADDR,0x0000);

}
#line 213 "C:/Users/antonius/Documents/FAT32 MP3 Player No TFT Rev4/MP3_driver.c"
void VsSineTest(void)

{

 UART_Write_Text("VS Sine Test Begin!\n");

 MP3_RST = 0;

 Delay_ms(100);
 SPI1_Write(0xFF);

 MP3_CS = 1;
 BSYNC = 1;

 MP3_RST = 1;



 Delay_ms(500);
 UART_Write_Text("SET VOLUME BEGIN Line226!\n");
 MP3_Set_Volume(0,0);
 LED = 1;
 Delay_ms(100);
 LED = 0;



 MP3_CS = 0;
 Mmc_Chip_Select = 1;

 MP3_SCI_Write(SCI_MODE_ADDR, 0x0820);
 Delay_ms(150);
 MP3_CS = 1;
 while (DREQ == 0);
 BSYNC = 0;
 SPI1_Write(0x53);
 SPI1_Write(0xEF);
 SPI1_Write(0x6E);
 SPI1_Write(0x44);
 SPI1_Write(0x00);
 SPI1_Write(0x00);
 SPI1_Write(0x00);
 SPI1_Write(0x00);
 Delay_ms(100);
 BSYNC = 1;
 Delay_ms(120);
 BSYNC = 0;
 SPI1_Write(0x45);
 SPI1_Write(0x78);
 SPI1_Write(0x69);
 SPI1_Write(0x74);
 SPI1_Write(0x00);
 SPI1_Write(0x00);
 SPI1_Write(0x00);
 SPI1_Write(0x00);
 Delay_ms(100);
 BSYNC = 1;
 Delay_ms(500);
 UART_Write_Text("VS Sine Test END!\r\n");
 }
